<html>
<head>
<title>OgreWin32GLSupport.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_5bc5f2f46c6364f2594540d45df3d051.html">GL</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7b8a29f58b064e3a63f570f2fc89729.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreWin32GLSupport.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreWin32GLSupport_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment"> -----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment"> This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment"> (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment"> For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"> </span>
<a name="l00007"></a>00007 <span class="comment"> Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"> </span>
<a name="l00009"></a>00009 <span class="comment"> Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment"> of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment"> in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment"> to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment"> copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment"> furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"> </span>
<a name="l00016"></a>00016 <span class="comment"> The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment"> all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"> </span>
<a name="l00019"></a>00019 <span class="comment"> THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment"> IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment"> FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment"> AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment"> LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment"> OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment"> THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment"> -----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment"> */</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __OgreWin32GLSupport_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __OgreWin32GLSupport_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreWin32Prerequisites_8h.html">OgreWin32Prerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLSupport_8h.html">OgreGLSupport.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLRenderSystem_8h.html">OgreGLRenderSystem.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Ogre
<a name="l00036"></a>00036 {
<a name="l00037"></a>00037     
<a name="l00038"></a><a class="code" href="classOgre_1_1Win32GLSupport.html">00038</a>     <span class="keyword">class </span><a class="code" href="OgreGLPrerequisites_8h.html#a84aebcce92aa9d20cdb06ab0eab6b1f8" title="Lots of generated code in here which triggers the new VC CRT security warnings.">_OgreGLExport</a> <a class="code" href="classOgre_1_1Win32GLSupport.html">Win32GLSupport</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1GLSupport.html">GLSupport</a>
<a name="l00039"></a>00039     {
<a name="l00040"></a>00040     <span class="keyword">public</span>:
<a name="l00041"></a>00041         <a class="code" href="classOgre_1_1Win32GLSupport.html">Win32GLSupport</a>();
<a name="l00047"></a>00047         <span class="keywordtype">void</span> addConfig();
<a name="l00048"></a>00048 
<a name="l00049"></a>00049         <span class="keywordtype">void</span> setConfigOption(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;value);
<a name="l00050"></a>00050 
<a name="l00054"></a>00054         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> validateConfig();
<a name="l00055"></a>00055 
<a name="l00056"></a>00056         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* createWindow(<span class="keywordtype">bool</span> autoCreateWindow, <a class="code" href="classOgre_1_1GLRenderSystem.html" title="Implementation of GL as a rendering system.">GLRenderSystem</a>* renderSystem, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; windowTitle = <span class="stringliteral">&quot;OGRE Render Window&quot;</span>);
<a name="l00057"></a>00057         
<a name="l00059"></a>00059         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* newWindow(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> width, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> height, 
<a name="l00060"></a>00060             <span class="keywordtype">bool</span> fullScreen, <span class="keyword">const</span> <a class="code" href="group__General.html#gadccb207c184efc0a6fb2a00ab6320d19" title="Name / value parameter pair (first = name, second = value)">NameValuePairList</a> *miscParams = 0);
<a name="l00061"></a>00061 
<a name="l00062"></a>00062         
<a name="l00066"></a>00066         <span class="keywordtype">void</span> start();
<a name="l00070"></a>00070         <span class="keywordtype">void</span> stop();
<a name="l00071"></a>00071 
<a name="l00075"></a>00075         <span class="keywordtype">void</span>* getProcAddress(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; procname);
<a name="l00076"></a>00076 
<a name="l00080"></a>00080         <span class="keyword">virtual</span> <span class="keywordtype">void</span> initialiseExtensions();
<a name="l00081"></a>00081         
<a name="l00082"></a>00082 
<a name="l00083"></a>00083         <span class="keywordtype">bool</span> selectPixelFormat(HDC hdc, <span class="keywordtype">int</span> colourDepth, <span class="keywordtype">int</span> multisample, <span class="keywordtype">bool</span> hwGamma);
<a name="l00084"></a>00084 
<a name="l00085"></a>00085         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> supportsPBuffers();
<a name="l00086"></a>00086         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1GLPBuffer.html" title="An off-screen rendering context.">GLPBuffer</a> *createPBuffer(<a class="code" href="group__Image.html#gac8f59c884998d9f84d9ea4c66e4c29fe" title="Pixel component format.">PixelComponentType</a> format, <span class="keywordtype">size_t</span> width, <span class="keywordtype">size_t</span> height);
<a name="l00087"></a>00087         <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> getDisplayMonitorCount() <span class="keyword">const</span>;
<a name="l00088"></a>00088     <span class="keyword">private</span>:
<a name="l00089"></a>00089         <span class="comment">// Allowed video modes</span>
<a name="l00090"></a><a class="code" href="classOgre_1_1Win32GLSupport.html#a10a2d00321cba1c0c93430e89aec5f1c">00090</a>         <a class="code" href="structOgre_1_1vector.html">vector&lt;DEVMODE&gt;::type</a> <a class="code" href="classOgre_1_1Win32GLSupport.html#a10a2d00321cba1c0c93430e89aec5f1c">mDevModes</a>;
<a name="l00091"></a><a class="code" href="classOgre_1_1Win32GLSupport.html#a5d1b969c7f9d8d6c3ed881af3abc538f">00091</a>         <a class="code" href="classOgre_1_1Win32Window.html">Win32Window</a> *<a class="code" href="classOgre_1_1Win32GLSupport.html#a5d1b969c7f9d8d6c3ed881af3abc538f">mInitialWindow</a>;
<a name="l00092"></a><a class="code" href="classOgre_1_1Win32GLSupport.html#a6dc3cd2f38d259b5339598eac6a86d3b">00092</a>         <a class="code" href="structOgre_1_1vector.html">vector&lt;int&gt;::type</a> <a class="code" href="classOgre_1_1Win32GLSupport.html#a6dc3cd2f38d259b5339598eac6a86d3b">mFSAALevels</a>;
<a name="l00093"></a><a class="code" href="classOgre_1_1Win32GLSupport.html#a99e1a1a2137741594a69cfdecb75afcf">00093</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Win32GLSupport.html#a99e1a1a2137741594a69cfdecb75afcf">mHasPixelFormatARB</a>;
<a name="l00094"></a><a class="code" href="classOgre_1_1Win32GLSupport.html#a4e42667e270e25bf52602e66d1d789e1">00094</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Win32GLSupport.html#a4e42667e270e25bf52602e66d1d789e1">mHasMultisample</a>;
<a name="l00095"></a><a class="code" href="classOgre_1_1Win32GLSupport.html#a643bf028ba8cc42848fb918885dfcc54">00095</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Win32GLSupport.html#a643bf028ba8cc42848fb918885dfcc54">mHasHardwareGamma</a>;
<a name="l00096"></a>00096 
<a name="l00097"></a><a class="code" href="structOgre_1_1Win32GLSupport_1_1DisplayMonitorInfo.html">00097</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1Win32GLSupport_1_1DisplayMonitorInfo.html">DisplayMonitorInfo</a>
<a name="l00098"></a>00098         {
<a name="l00099"></a><a class="code" href="structOgre_1_1Win32GLSupport_1_1DisplayMonitorInfo.html#a6d141d63f40c3d907a4f741054f2676d">00099</a>             HMONITOR        <a class="code" href="structOgre_1_1Win32GLSupport_1_1DisplayMonitorInfo.html#a6d141d63f40c3d907a4f741054f2676d">hMonitor</a>;
<a name="l00100"></a><a class="code" href="structOgre_1_1Win32GLSupport_1_1DisplayMonitorInfo.html#a539cb79cfb061d7628f373557e18f97e">00100</a>             MONITORINFOEX   <a class="code" href="structOgre_1_1Win32GLSupport_1_1DisplayMonitorInfo.html#a539cb79cfb061d7628f373557e18f97e">monitorInfoEx</a>;
<a name="l00101"></a>00101         };
<a name="l00102"></a>00102 
<a name="l00103"></a><a class="code" href="classOgre_1_1Win32GLSupport.html#a80fdc9b4141dd2a7c1ce5f3c7c9a6373">00103</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;DisplayMonitorInfo&gt;::type</a> <a class="code" href="classOgre_1_1Win32GLSupport.html#a80fdc9b4141dd2a7c1ce5f3c7c9a6373">DisplayMonitorInfoList</a>;
<a name="l00104"></a><a class="code" href="classOgre_1_1Win32GLSupport.html#af03edb63d266027d54aa6f80c106624d">00104</a>         <span class="keyword">typedef</span> DisplayMonitorInfoList::iterator <a class="code" href="classOgre_1_1Win32GLSupport.html#af03edb63d266027d54aa6f80c106624d">DisplayMonitorInfoIterator</a>;
<a name="l00105"></a>00105 
<a name="l00106"></a><a class="code" href="classOgre_1_1Win32GLSupport.html#a7552bb267ac26600f81fe659fc655975">00106</a>         <a class="code" href="classOgre_1_1Win32GLSupport.html#a80fdc9b4141dd2a7c1ce5f3c7c9a6373">DisplayMonitorInfoList</a> <a class="code" href="classOgre_1_1Win32GLSupport.html#a7552bb267ac26600f81fe659fc655975">mMonitorInfoList</a>;
<a name="l00107"></a>00107 
<a name="l00108"></a>00108         <span class="keywordtype">void</span> refreshConfig();
<a name="l00109"></a>00109         <span class="keywordtype">void</span> initialiseWGL();
<a name="l00110"></a>00110         <span class="keyword">static</span> LRESULT CALLBACK dummyWndProc(HWND hwnd, UINT umsg, WPARAM wp, LPARAM lp);
<a name="l00111"></a>00111         <span class="keyword">static</span> BOOL CALLBACK sCreateMonitorsInfoEnumProc(HMONITOR hMonitor, HDC hdcMonitor, 
<a name="l00112"></a>00112             LPRECT lprcMonitor, LPARAM dwData);
<a name="l00113"></a>00113     };
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 }
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:53
</p>
</body>
</html>
